SystemOrganization addCategory: #'Mentor-Core'!

!RefersClassTrait methodsFor: '*Mentor-Core' stamp: 'AndyKellens 7/30/2012 15:28'!
importanceForClass
	^3! !

!RefersClassTrait methodsFor: '*Mentor-Core' stamp: 'AndyKellens 7/30/2012 15:26'!
importanceForMethods 
	^4! !

!UnderstandsMessageTrait methodsFor: '*Mentor-Core' stamp: 'AndyKellens 7/30/2012 15:28'!
importanceForClass
	^3! !

!UnderstandsMessageTrait methodsFor: '*Mentor-Core' stamp: 'AndyKellens 7/30/2012 15:26'!
importanceForMethods 
	^2! !

!CallsTrait methodsFor: '*Mentor-Core' stamp: 'AndyKellens 7/30/2012 15:27'!
importanceForClass
	^3! !

!CallsTrait methodsFor: '*Mentor-Core' stamp: 'AndyKellens 7/30/2012 15:25'!
importanceForMethods 
	^3! !

!InHierarchyTrait methodsFor: '*Mentor-Core' stamp: 'AndyKellens 7/30/2012 15:28'!
importanceForClass
	^1! !

!InHierarchyTrait methodsFor: '*Mentor-Core' stamp: 'AndyKellens 7/30/2012 15:26'!
importanceForMethods 
	^2! !

!InProtocolTrait methodsFor: '*Mentor-Core' stamp: 'AndyKellens 7/30/2012 15:28'!
importanceForClass
	^3! !

!InProtocolTrait methodsFor: '*Mentor-Core' stamp: 'AndyKellens 7/30/2012 15:26'!
importanceForMethods 
	^2! !

!KeywordTrait methodsFor: '*Mentor-Core' stamp: 'AndyKellens 7/30/2012 15:28'!
importanceForClass
	^2! !

!KeywordTrait methodsFor: '*Mentor-Core' stamp: 'AndyKellens 7/30/2012 15:26'!
importanceForMethods 
	^5! !

!ImplementsMessageTrait methodsFor: '*Mentor-Core' stamp: 'AndyKellens 7/30/2012 15:28'!
importanceForClass
	^2! !

!ImplementsMessageTrait methodsFor: '*Mentor-Core' stamp: 'AndyKellens 7/30/2012 15:26'!
importanceForMethods 
	^2! !

Object subclass: #AbstractCodeMiner
	instanceVariableNames: 'objects projectName context associationRules miner roots groupedRules'
	classVariableNames: 'RuleRepository'
	poolDictionaries: ''
	category: 'Mentor-Core'!

!AbstractCodeMiner class methodsFor: 'rule repository' stamp: 'AndyKellens 7/30/2012 11:19'!
addRulesForProject: aProjectName rules: associationRules

	(self ruleRepository at: aProjectName) addAll: associationRules! !

!AbstractCodeMiner class methodsFor: 'rule repository' stamp: 'AndyKellens 7/30/2012 11:18'!
clearRepository

	RuleRepository := Dictionary new! !

!AbstractCodeMiner class methodsFor: 'rule repository' stamp: 'AndyKellens 7/30/2012 11:19'!
hasRulesForProject: aProjectName

	^self ruleRepository includesKey: aProjectName! !

!AbstractCodeMiner class methodsFor: 'defaults' stamp: 'AndyKellens 7/30/2012 11:17'!
minimumConfidence
	^0.7! !

!AbstractCodeMiner class methodsFor: 'defaults' stamp: 'AndyKellens 7/30/2012 11:17'!
minimumDegreeOfError
	^0.55! !

!AbstractCodeMiner class methodsFor: 'defaults' stamp: 'AndyKellens 7/30/2012 11:17'!
minimumSupport
	^4! !

!AbstractCodeMiner class methodsFor: 'instance creation' stamp: 'AndyKellens 7/30/2012 11:22'!
objects: aCollection project: aProjectName
	^super new initializeWithObjects: aCollection projectName: aProjectName! !

!AbstractCodeMiner class methodsFor: 'filtering' stamp: 'AndyKellens 7/30/2012 11:17'!
preFilterClasses: aCollection
	^ aCollection removeAllSuchThat:	[ :each | TestCase allSubclasses includes: each ]; yourself.! !

!AbstractCodeMiner class methodsFor: 'rule repository' stamp: 'AndyKellens 7/30/2012 11:18'!
ruleRepository
	RuleRepository ifNil:[RuleRepository := Dictionary new].
	^RuleRepository! !

!AbstractCodeMiner class methodsFor: 'rule repository' stamp: 'AndyKellens 9/27/2012 15:13'!
rulesAndPropertiesForEntity: anEntity
	| allMatchingRules entityProperties |
	entityProperties := anEntity mendelTraits.
	allMatchingRules := Set new.
	self ruleRepository keysAndValuesDo: [:project :rules |
		| candidates |
		candidates := (anEntity isKindOf: ClassDescription )
							ifTrue:[rules select:#isClassRule]
							ifFalse:[rules reject:#isClassRule].
		allMatchingRules addAll:(candidates select:[:rule | (rule condition intersection: (entityProperties)) notEmpty])].
	^allMatchingRules -> entityProperties
	! !

!AbstractCodeMiner class methodsFor: 'rule repository' stamp: 'AndyKellens 7/30/2012 11:20'!
rulesAtProject: aProjectName put: aCollection
	self ruleRepository at: aProjectName put: aCollection! !

!AbstractCodeMiner class methodsFor: 'rule repository' stamp: 'AndyKellens 7/30/2012 11:20'!
rulesForProject: aProjectName

	^self ruleRepository at: aProjectName ifAbsent: [OrderedCollection new]! !

!AbstractCodeMiner class methodsFor: 'rule repository' stamp: 'AndyKellens 7/30/2012 11:21'!
storeRulesOfMiner: aMiner
	(self hasRulesForProject: aMiner projectName)
		ifTrue:[self addRulesForProject: aMiner projectName rules: aMiner associationGroups]
		ifFalse:[self rulesAtProject: aMiner projectName put: aMiner associationGroups]! !

!AbstractCodeMiner methodsFor: 'filtering' stamp: 'AndyKellens 7/30/2012 13:45'!
FILTERS2LeftToRight
	| toAnalyze |
	Transcript show:'Number of rules before applying S2: Left to right: ', associationRules size asString;cr.
	toAnalyze := associationRules copy.
	toAnalyze do:[:rule | |newRule|
		newRule := AssociationRule 	condition: (rule conclusion) 
									conclusion: (rule condition) 
									conditionSupport: (rule conclusionSupport) 
									conclusionSupport: (rule conditionSupport) 
									matches: (rule matches) 
									conditionExceptions: (rule conclusionExceptions) 
									conclusionExceptions: (rule conditionExceptions)
									objectsAnalyzed: (rule objectsAnalyzed).
		(rule conditionExceptions size > rule conclusionExceptions size) 
				ifTrue:[associationRules remove: rule ifAbsent:[]; add: newRule] ].
	Transcript show:'Number of rules after applying S2: Left to right: ', associationRules size asString;cr.! !

!AbstractCodeMiner methodsFor: 'filtering' stamp: 'AndyKellens 7/30/2012 13:45'!
FILTERS4eliminateByDegreeOfError
	| toEliminate |
	"Filter S4 (error)"
	Transcript show:'Number of rules before applying S4:  Error: ', associationRules size asString;cr.
	toEliminate := associationRules reject:[:rule | ( rule error ) <  (self class minimumDegreeOfError)].
	associationRules removeAll: toEliminate.
	Transcript show:'Number of rules after applying S4:  Error: ', associationRules size asString;cr.! !

!AbstractCodeMiner methodsFor: 'filtering' stamp: 'AndyKellens 7/30/2012 13:45'!
FILTERS5CompactRules
	| newrules implications overlap numOfProperties |
	Transcript show:'Number of rules before applying S5:  Compact rules ', associationRules size asString;cr.
	"This method aims at reducing the redundant conditions/conclusions of rules based on the implication rules"
	numOfProperties := 0.
	associationRules do:[:rule | numOfProperties := numOfProperties+rule condition size + rule conclusion size].
	numOfProperties := numOfProperties / (associationRules size).
	"First, filter the set of all rules to only consider implications"
	implications := (associationRules select:[:rule | rule confidence = 1]) asSortedCollection:[:imp1 :imp2 | (imp2 conclusion includesAll: imp1 condition) or:[imp1 conclusion includesAll: (imp2 conclusion)] ].
	newrules := Set new.
	associationRules do:[:association | 
			| newassoc |
			newassoc := association copy.
			"Case 1: A =>(100pct) B; A,B ->C  =====> Prune this to A -> C"
			(implications select:[:implication | (newassoc condition includesAll: (implication condition union: implication conclusion))])
					do:[:applicableimplication | 
							((newassoc condition size > 1)) ifTrue:[
							newassoc := 
								(AssociationRule 
									condition: (newassoc condition copy removeAll: (applicableimplication conclusion) ifAbsent:[];yourself) 
									conclusion: (newassoc conclusion copy) 
									conditionSupport: (newassoc conditionSupport) 
									conclusionSupport: (newassoc conclusionSupport) 
									matches: (newassoc matches)
									conditionExceptions: (newassoc conditionExceptions)
									conclusionExceptions: (newassoc conclusionExceptions)
									objectsAnalyzed: (newassoc objectsAnalyzed)
									)]].
			"Case 2: A =>(100pct)B, C -> A, B ======> Prune this to C -> A"
			(implications select:[:implication | (newassoc conclusion includesAll: (implication condition union: implication conclusion))])
					do:[:applicableimplication | 
							((newassoc conclusion size > 1)) ifTrue:[
							newassoc := 
								(AssociationRule 
									condition: (newassoc condition copy) 
									conclusion: (newassoc conclusion copy removeAll: (applicableimplication conclusion) ifAbsent:[];yourself) 
									conditionSupport: (newassoc conditionSupport) 
									conclusionSupport: (newassoc conclusionSupport) 
									matches: (newassoc matches)
									conditionExceptions: (newassoc conditionExceptions)
									conclusionExceptions: (newassoc conclusionExceptions)
									objectsAnalyzed: (newassoc objectsAnalyzed))]].
		"After pruning the rule, it might become identical to another rule, but with higher/lower confidence"
		"In this case, we choose the one with the highest confidence"
		overlap := newrules detect:[:newrule| newrule condition = (newassoc condition) and:[newassoc conclusion includesAll: (newrule conclusion)]] ifNone:[nil].
		overlap isNil 
					ifTrue:[newrules add: newassoc]
					ifFalse:[(overlap confidence > newassoc confidence) 
						ifFalse:[
							newrules remove: overlap. newrules add: newassoc]]].
	associationRules := newrules.

	numOfProperties := 0.
	associationRules do:[:rule | numOfProperties := numOfProperties + rule condition size + rule conclusion size].
	numOfProperties := numOfProperties / (associationRules size).
	Transcript show:'Number of rules after applying S5:  Compact rules ', associationRules size asString;cr.! !

!AbstractCodeMiner methodsFor: 'filtering' stamp: 'AndyKellens 7/30/2012 15:05'!
FILTERS6RedundantSuperProperty
	| implications toRemove|
	"This method aims at reducing the redundant conditions/conclusions of rules based on the implication rules"
	"First, filter the set of all rules to only consider implications"
	Transcript show:'Number of rules before applying S6:  Redundant mention of super-property', associationRules size asString;cr.
	implications := (associationRules select:[:rule | rule confidence = 1]) asSortedCollection:[:imp1 :imp2 | (imp2 condition includesAll: imp1 condition) or:[imp1 conclusion includesAll: (imp2 conclusion)] ].
	toRemove := Set new.
	associationRules do:[:association | 
			| newassoc |
			"Case 1: A =>(100pct) B, A --> BC  =====> Prune this to A --> C"
			(implications select:[:implication | 	(((association condition includesAll: (implication condition)) 
											and:[implication condition includesAll: (association condition)])
											and:[association  conclusion includesAll: (implication conclusion)] )
											and:[(implication = association) not ] ])
					do:[:applicableimplication | 
							| metrics |
							metrics := miner calculateSupportForCondition:  (association condition collect:[:attr | context attributes at: attr])  conclusion: ((association conclusion copy removeAll: (applicableimplication conclusion) ifAbsent:[];yourself) collect:[:attr | context attributes at: attr]).
							newassoc := 
								(AssociationRule 
									condition: (association condition copy) 
									conclusion: (association conclusion copy removeAll: (applicableimplication conclusion) ifAbsent:[];yourself) 
									conditionSupport: (metrics at:1)
									conclusionSupport: (metrics at:2)			
									matches: (metrics at:3)
									conditionExceptions: (metrics at:4)
									conclusionExceptions: (metrics at:5)
									objectsAnalyzed: (metrics at:6)).
							((newassoc conclusion size > 1) and:[newassoc error < association error]) ifTrue:[
								toRemove add: association.
								associationRules add: newassoc.
								"debug = 1 ifTrue:[Transcript show:'     Case H1: - ',association asString,' + ',newassoc asString,' by ',applicableimplication asString;cr].
							"].]].
	associationRules removeAll: toRemove.
	Transcript show:'Number of rules after applying S6:  Redundant mention of super-property', associationRules size asString;cr.! !

!AbstractCodeMiner methodsFor: 'filtering' stamp: 'AndyKellens 7/30/2012 13:46'!
FILTERS7S8SuperSubSameProperties
	| implications toRemove rulesWithSameCond rulesWithSameConcl pairs removedSize|
	"This method aims at reducing the redundant rules based on the matches-exceptions relation"
	toRemove := OrderedCollection new.
	associationRules size.
	Transcript show:'Number of rules before applying S7:  Super and sub are concluded by same', associationRules size asString;cr.
	"First, filter the set of all rules to only consider implications"
	implications := (associationRules select:[:rule | rule confidence = 1]) asSortedCollection:[:imp1 :imp2 | (imp2 condition includesAll: imp1 condition) or:[imp1 conclusion includesAll: (imp2 conclusion)] ].
	pairs := Dictionary new.
	rulesWithSameCond := associationRules groupedBy:[:association | association condition ].
	rulesWithSameCond do:[:rules| rules do:[:association1 | 
		rules do:[:association2 |  
			(implications do:[:implication | 
				((association1 conclusion asSet equalsTo: (implication condition asSet)) and:[((association2 conclusion intersection: (implication conclusion)) size > 0) and:[((association2 conclusion difference: (implication conclusion)) size = 0)]] )
				ifTrue:[((pairs at: association2 ifAbsent:[nil]) = association1)
					ifFalse:[ (association1 = association2) not
					ifTrue:[pairs at:association1 put: association2].].].]). ]. ]. ]. 
	toRemove addAll: (self selectRules: pairs).
	pairs := Dictionary new.
	Transcript show:'Number of rules after applying S7:  Super and sub are concluded by same', (associationRules size - (toRemove size)) asString ;cr.
	Transcript show:'Number of rules before applying S8:  Super and sub conclude same', (associationRules size - (toRemove size)) asString;cr.
	rulesWithSameConcl := associationRules groupedBy:[:association | association conclusion ].
	removedSize := toRemove size .
	rulesWithSameConcl do:[:rules| rules do:[:association1|  
					rules do:[:association2| 
						(implications do:[:implication | 
								((association1 condition asSet equalsTo: (implication condition asSet)) and:[((association2 condition intersection: (implication conclusion)) size > 0) and:[((association2 condition difference: (implication conclusion)) size = 0)]] )
								ifTrue:[((pairs at: association2 ifAbsent:[nil]) = association1)
									ifFalse:[(association1 = association2) not
										ifTrue:[pairs at:association1 put: association2].].].]). ]. ]. ]. 
	toRemove addAll: (self selectRules: pairs).
	associationRules removeAll: toRemove ifAbsent:[].
	removedSize := (toRemove size) - removedSize.
	Transcript show:'Number of rules after applying S8:  Super and sub conclude same', (associationRules size asString);cr.! !

!AbstractCodeMiner methodsFor: 'filtering' stamp: 'AndyKellens 7/30/2012 13:46'!
POSTFILTEReliminateRepeated
	| toAnalyze |
	Transcript show:'Number of rules before removing duplicates:', (associationRules size asString);cr.
	toAnalyze := associationRules copy.
	toAnalyze do:[:rule | | other |
		(associationRules 
				anySatisfy:[:otherrule | 
						other := otherrule.
						rule condition asSet = otherrule conclusion asSet and:[rule conclusion asSet = otherrule condition asSet]]) 
							ifTrue:[(rule condition size > rule conclusion size) 
									ifTrue:[associationRules remove: rule ifAbsent:[]] 
									ifFalse:[associationRules remove: other ifAbsent:[]]]].
	Transcript show:'Number of rules after removing duplicates:', (associationRules size asString);cr.! !

!AbstractCodeMiner methodsFor: 'filtering' stamp: 'AndyKellens 7/30/2012 11:30'!
PREFILTERUnitTests: anObject
	^(anObject isKindOf: ClassDescription)
		ifTrue:[(anObject allSuperclasses includes: TestCase) not]
		ifFalse:[true]! !

!AbstractCodeMiner methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 15:24'!
associationGroups
	^associationRules! !

!AbstractCodeMiner methodsFor: 'private' stamp: 'AngelaLozano 9/27/2012 16:45'!
checkIfClass: aSubclass inheritsFrom: aSuperclass
	^aSuperclass allSubclasses includes: (Smalltalk at:aSubclass ifAbsent:[aSubclass])! !

!AbstractCodeMiner methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 15:25'!
context
	^context! !

!AbstractCodeMiner methodsFor: 'private mining' stamp: 'AndyKellens 7/30/2012 11:28'!
createConcepts

	| objectsToBeAnalyzed |
	"PREFILTERING on objects to be analyzed"
	objectsToBeAnalyzed := objects select: [: each | self PREFILTERUnitTests: each ].
	context := ConceptContext
		fromBlocksForObjects: objectsToBeAnalyzed
		relations:
			[:object | object mendelTraits].
	context createConcepts.
	context pruneLattice! !

!AbstractCodeMiner methodsFor: 'private' stamp: 'AndyKellens 7/30/2012 11:24'!
filterRules
	self subclassResponsibility ! !

!AbstractCodeMiner methodsFor: 'private mining' stamp: 'AndyKellens 7/30/2012 13:49'!
groupRules
	| toGroup |
	toGroup := Dictionary new.
	associationRules do:[:rule | 
			(toGroup at: (rule matches asSet) ifAbsentPut:[Set new]) add: rule].
	groupedRules := toGroup values asSortedCollection:[:g1 :g2 | g1 size >= g2 size]! !

!AbstractCodeMiner methodsFor: 'initialize-release' stamp: 'AndyKellens 7/30/2012 15:22'!
initializeWithObjects: aCollection projectName: aProjectName
	objects := aCollection.
	projectName := aProjectName.
	roots := Set new! !

!AbstractCodeMiner methodsFor: 'mining' stamp: 'AndyKellens 7/30/2012 14:12'!
mine
	self createConcepts.
	Transcript cr; cr; show: 'Number of Concepts: ', context concepts size printString; cr.
	Transcript show: 'Number of Relations in the Incidence Table: ', context totalNumberOfRelations printString;cr.
	self mineAssociationRules.
	Transcript show: 'Association rules before any filtering: ', (associationRules size) printString; cr.
	self filterRules.
	Transcript show: 'Final rules after filtering: ',( associationRules size) printString; cr.
	self class storeRulesOfMiner: self! !

!AbstractCodeMiner methodsFor: 'private mining' stamp: 'AndyKellens 7/30/2012 13:44'!
mineAssociationRules
	miner := AssociationRuleMiner onContext: context.
	AssociationRuleMiner minimumSupport: (self class minimumSupport).
	AssociationRuleMiner minimumConfidence: (self class minimumConfidence).
	associationRules := miner mine! !

!AbstractCodeMiner methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:23'!
objects
	^objects! !

!AbstractCodeMiner methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:23'!
projectName
	^projectName! !

!AbstractCodeMiner methodsFor: 'filtering' stamp: 'AndyKellens 7/30/2012 15:22'!
removeRulesWithRootsAsConclusion

	"This method only works for Smalltalk case studies. It should be generalized by any root of classes"

	" This filters tests if X>B -> H>A, and A is one of the roots of the system => ignore rule" 
	| oneConclusion hierarchyAsConclusion classAsConclusion condition  toBeRemoved |
	Transcript show:'Number of rules before removing rules concluding roots: ', (associationRules size asString);cr.
	oneConclusion := [:eachRule | eachRule hasOnePropertyAsConclusion].
	hierarchyAsConclusion := [:eachRule| eachRule firstConclusionProperty isHierarchyTrait].
	classAsConclusion := [:eachRule | | concClass | concClass := eachRule firstConclusionProperty value. roots includes: concClass].
	condition:= [:rule | (oneConclusion value: rule) and: [(hierarchyAsConclusion value: rule) and: [classAsConclusion value:rule]]].
	toBeRemoved:= (associationRules  select: [:rule | (condition value: rule)]).
	associationRules:= (associationRules asOrderedCollection reject: [:rule | (condition value: rule)]) asSet.
	Transcript show:'Number of rules after removing rules concluding roots: ', (associationRules size asString);cr.! !

!AbstractCodeMiner methodsFor: 'private' stamp: 'AndyKellens 7/30/2012 13:47'!
selectRules: aCollectionOfPairsOfRules
	| debug toRemove |
	"This method aims at reducing the redundant rules based on the mches-exceptions relation"
	debug := 0.
	toRemove := OrderedCollection new.
	aCollectionOfPairsOfRules keysAndValuesDo:[:association1 :association2 | 
			(( association1 confidence >= association2 confidence ) and:[association1 error < association2 error])
					ifTrue:[	debug = 1 ifTrue:[Transcript show:'=a1(sub): ',association1 asString,'-a2(super): ',association2 asString.].
							toRemove add: association2.]
					ifFalse:[	debug = 1 ifTrue:[Transcript show:'-a1(sub): ',association1 asString,'=a2(super): ',association2 asString.].
							toRemove add: association1.].].
	^toRemove! !

AbstractCodeMiner subclass: #ClassCodeMiner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mentor-Core'!

!ClassCodeMiner methodsFor: 'filtering' stamp: 'AndyKellens 7/30/2012 15:22'!
FILTERH1filterHierarchyRulesWithSuperclassInConclusion 

	| bothHierarchyProps sameHierarchy condition |
	Transcript show:'Number of rules before applying H1: Hierarchy relations: ', associationRules size asString;cr.
	bothHierarchyProps := [:eachRule| (eachRule firstConditionProperty isHierarchyTrait) and: [eachRule firstConclusionProperty isHierarchyTrait]].
	sameHierarchy := [:eachRule | | condClass concClass | condClass := eachRule firstConditionProperty value. concClass := eachRule firstConclusionProperty value. 
					self checkIfClass: condClass inheritsFrom: concClass].
	condition:= [:rule | (rule isUnique) and: [(rule hasConfidence: 1) and: [(bothHierarchyProps value: rule) and: [sameHierarchy value:rule]]]].
	associationRules:= (associationRules asOrderedCollection reject: [:rule | (condition value: rule)]) asSet.
	Transcript show:'Number of rules after applying H1: Hierarchy relations: ', associationRules size asString;cr.! !

!ClassCodeMiner methodsFor: 'filtering' stamp: 'AndyKellens 7/30/2012 15:24'!
filterRules
	self FILTERS2LeftToRight.
	self FILTERS4eliminateByDegreeOfError.
	self FILTERS5CompactRules.
	self FILTERS6RedundantSuperProperty.
	self FILTERS7S8SuperSubSameProperties.
	self FILTERH1filterHierarchyRulesWithSuperclassInConclusion.
	self removeRulesWithRootsAsConclusion.
	self POSTFILTEReliminateRepeated.! !

AbstractCodeMiner subclass: #MethodCodeMiner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mentor-Core'!

!MethodCodeMiner methodsFor: 'filtering' stamp: 'AndyKellens 7/30/2012 15:37'!
FILTERH1KeywordKeyword
	associationRules:= (associationRules asOrderedCollection reject: [:rule | (rule condition allSatisfy:[:c | c isKeywordTrait]) and:[rule conclusion allSatisfy:[:c | c isKeywordTrait]]]) asSet.! !

!MethodCodeMiner methodsFor: 'filtering' stamp: 'AndyKellens 7/30/2012 13:50'!
filterRules
	self FILTERH1KeywordKeyword.
	self FILTERS2LeftToRight.
	self FILTERS5CompactRules.
	self FILTERS6RedundantSuperProperty.
	self FILTERS7S8SuperSubSameProperties.
	self FILTERS4eliminateByDegreeOfError.
	self POSTFILTEReliminateRepeated.! !

Object subclass: #AssociationRule
	instanceVariableNames: 'condition conclusion matches conditionSupport conclusionSupport conditionExceptions conclusionExceptions objectsAnalyzed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mentor-Core'!

!AssociationRule class methodsFor: 'instance creation' stamp: 'AndyKellens 7/30/2012 11:43'!
condition: aCollection1 conclusion: aCollection2 conditionSupport: aNumber1 conclusionSupport: aNumber2 matches: aNumber conditionExceptions: conditionExceptions conclusionExceptions: conclusionExceptions objectsAnalyzed: aNumber3
	^super new
		condition: aCollection1 asSet;
		conclusion: aCollection2 asSet;
		matches: aNumber;
		conditionSupport: aNumber1;
		conclusionSupport: aNumber2;
		conditionExceptions: conditionExceptions;
		conclusionExceptions: conclusionExceptions;
		objectsAnalyzed: aNumber3! !

!AssociationRule methodsFor: 'comparing' stamp: 'AndyKellens 7/30/2012 11:46'!
= aRule
	^aRule conclusion = conclusion and:[aRule condition = condition]! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
conclusion
	^ conclusion! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
conclusion: anObject
	conclusion := anObject! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
conclusionExceptions
	^ conclusionExceptions! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
conclusionExceptions: anObject
	conclusionExceptions := anObject! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
conclusionSupport
	^ conclusionSupport! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
conclusionSupport: anObject
	conclusionSupport := anObject! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
condition
	^ condition! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
condition: anObject
	condition := anObject! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
conditionExceptions
	^ conditionExceptions! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
conditionExceptions: anObject
	conditionExceptions := anObject! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
conditionSupport
	^ conditionSupport! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
conditionSupport: anObject
	conditionSupport := anObject! !

!AssociationRule methodsFor: 'metrics' stamp: 'AndyKellens 7/30/2012 11:45'!
confidence
	^matches size / conditionSupport size! !

!AssociationRule methodsFor: 'metrics' stamp: 'AndyKellens 7/30/2012 11:46'!
conviction
	| conviction |
	"conviction := (objectsAnalyzed - (conclusionSupport size)) / (objectsAnalyzed - (matches size))."
	matches size = conditionSupport size
		ifFalse:[conviction := (1- (conclusionSupport size/objectsAnalyzed)) / (1 - (matches size/conditionSupport size))]
		ifTrue:[conviction := 99999].
	^conviction! !

!AssociationRule methodsFor: 'metrics' stamp: 'AndyKellens 7/30/2012 11:45'!
error
	^1- (((matches size / conditionSupport size) + (matches size / conclusionSupport size)) / 2)! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:47'!
firstConclusionProperty

	"Answers the first property in the list of properties in the conclusion of the association Rule. it is useful when you have A - > B and |A| = |B| = 1"

	^self conclusion asOrderedCollection first! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:47'!
firstConditionProperty

	"Answers the first property in the list of properties in the condition of the association Rule. it is useful when you have A - > B and |A| = |B| = 1"

	^self condition asOrderedCollection first! !

!AssociationRule methodsFor: 'testing' stamp: 'AndyKellens 7/30/2012 11:47'!
hasConfidence: aNumber

	^self confidence = aNumber! !

!AssociationRule methodsFor: 'testing' stamp: 'AndyKellens 7/30/2012 11:47'!
hasOnePropertyAsConclusion

	^self conclusion size = 1! !

!AssociationRule methodsFor: 'testing' stamp: 'AndyKellens 7/30/2012 11:47'!
hasOnePropertyAsCondition

	^self condition size = 1! !

!AssociationRule methodsFor: 'testing' stamp: 'AndyKellens 7/30/2012 11:47'!
hasSameConditionAs: anAssociationRule

	^self condition = anAssociationRule condition! !

!AssociationRule methodsFor: 'comparing' stamp: 'AndyKellens 7/30/2012 11:46'!
hash
	^self confidence hash! !

!AssociationRule methodsFor: 'testing' stamp: 'AndyKellens 9/27/2012 15:13'!
isClassRule
	^matches anyOne wrappedElement isKindOf: ClassDescription! !

!AssociationRule methodsFor: 'testing' stamp: 'AndyKellens 7/30/2012 11:47'!
isUnique

	"Answers true if the implication A->B has only one property in A and one property in B"

	^self hasOnePropertyAsConclusion and:[self hasOnePropertyAsCondition]! !

!AssociationRule methodsFor: 'metrics' stamp: 'AndyKellens 7/30/2012 11:48'!
lift
	| lift |
	lift := (matches size / conditionSupport size) / ((conclusionSupport size/objectsAnalyzed)).
	^lift! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
matches
	^ matches! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
matches: anObject
	matches := anObject! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
objectsAnalyzed
	^ objectsAnalyzed! !

!AssociationRule methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 11:45'!
objectsAnalyzed: anObject
	objectsAnalyzed := anObject! !

!AssociationRule methodsFor: 'printing' stamp: 'AndyKellens 7/30/2012 11:46'!
printOn: aStream
	| typeOfRule lift conviction |
	conditionExceptions size > 0
		ifTrue: [typeOfRule := '-']
		ifFalse: [typeOfRule := '='].
	condition do:[:c | c printOn: aStream] separatedBy:[aStream nextPut:$,].
	aStream nextPutAll:'(', conditionExceptions size asString,')  ',typeOfRule,"'['," (self matches size asString),' (',(self confidence asFloat * 100) rounded asString,'%)'"]'",typeOfRule,'> ',' (', conclusionExceptions size asString, ')'.

	conclusion do:[:c | c printOn: aStream] separatedBy:[aStream nextPut:$,].
	aStream nextPutAll: ' ';cr.
	! !

Object subclass: #AssociationRuleMiner
	instanceVariableNames: 'context consideredConcepts rules pruneNoMatches pruneNoConfidence allRules objectsCache'
	classVariableNames: 'MinimumConfidence MinimumSupport'
	poolDictionaries: ''
	category: 'Mentor-Core'!

!AssociationRuleMiner class methodsFor: 'configuration' stamp: 'AndyKellens 7/30/2012 13:39'!
minimumConfidence
	^MinimumConfidence ifNil:[0.5] ifNotNil:[MinimumConfidence]! !

!AssociationRuleMiner class methodsFor: 'configuration' stamp: 'AndyKellens 7/30/2012 13:39'!
minimumConfidence: aNumber
	MinimumConfidence := aNumber! !

!AssociationRuleMiner class methodsFor: 'configuration' stamp: 'AndyKellens 7/30/2012 13:39'!
minimumSupport
	^MinimumSupport ifNil:[0] ifNotNil:[MinimumSupport]! !

!AssociationRuleMiner class methodsFor: 'configuration' stamp: 'AndyKellens 7/30/2012 13:39'!
minimumSupport: aNumber
	MinimumSupport := aNumber! !

!AssociationRuleMiner class methodsFor: 'configuration' stamp: 'AndyKellens 7/30/2012 13:39'!
onContext: aContext
	^super new context: aContext! !

!AssociationRuleMiner methodsFor: 'private mining' stamp: 'AndyKellens 7/30/2012 13:41'!
calculateSupportForCondition: conditionSet conclusion: conclusionSet
	| result conditionSupport conclusionSupport matches exceptionCondition exceptionConclusion |
	conditionSupport := conditionSet inject: (conditionSet asOrderedCollection first relationBitRep) into:[:prev :current | prev bitAnd:(current relationBitRep)].
	conclusionSupport := conclusionSet inject: (conclusionSet asOrderedCollection first relationBitRep) into:[:prev :current | prev bitAnd:(current relationBitRep)].
	matches := conditionSupport bitAnd:conclusionSupport.
	
	exceptionCondition := conditionSupport bitXor: matches.
	exceptionConclusion := conclusionSupport bitXor: matches.

	result := OrderedCollection new.
	result 
		add: (self lookupObjectsRepresentedBy: conditionSupport);
		add: (self lookupObjectsRepresentedBy: conclusionSupport);
		add:  (self lookupObjectsRepresentedBy: matches);
		add:  (self lookupObjectsRepresentedBy: exceptionCondition);
		add:  (self lookupObjectsRepresentedBy: exceptionConclusion);
		add:  (self context objects size).
	^result! !

!AssociationRuleMiner methodsFor: 'private implication mining' stamp: 'AndyKellens 7/30/2012 13:42'!
considerSubsetsWithOneLessOf: aCollection
	| result |
	"Calculate all subsets of n - 1 elements"
	result := OrderedCollection new.
	(1 to: aCollection size) do:[:n | result add: (aCollection copyWithoutIndex: n)].
	^result! !

!AssociationRuleMiner methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 13:40'!
context
	^context! !

!AssociationRuleMiner methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 13:40'!
context: aContext
	context := aContext! !

!AssociationRuleMiner methodsFor: 'initialize-release' stamp: 'AndyKellens 7/30/2012 13:40'!
initialize
	super initialize.
	pruneNoMatches := 0.
	pruneNoConfidence := 0.
	allRules := 0.
	objectsCache := Dictionary new! !

!AssociationRuleMiner methodsFor: 'private mining' stamp: 'AndyKellens 7/30/2012 13:41'!
lookupObjectsRepresentedBy: aBitRep
	^objectsCache at:aBitRep ifAbsentPut:[self context objectsRepresentendBy: aBitRep]! !

!AssociationRuleMiner methodsFor: 'mining' stamp: 'AndyKellens 7/30/2012 13:41'!
mine
	rules := Set new.
	self selectConcepts.
	self mineImplications.
	self mineAssociations.
	^rules! !

!AssociationRuleMiner methodsFor: 'private association mining' stamp: 'AndyKellens 7/30/2012 13:41'!
mineAssociations
	rules addAll: (self mineAssociationsBetweenParentAndChild).
	rules addAll: (self mineAssociationsBetweenSiblings)! !

!AssociationRuleMiner methodsFor: 'private association mining' stamp: 'AndyKellens 7/30/2012 13:41'!
mineAssociationsBetweenParentAndChild
	| result |
	result := OrderedCollection new.
	consideredConcepts do:[:considered |
		(considered smallerOnes select:[:smallerOne | consideredConcepts includes: smallerOne]) 
			do:[:childConcept |
					| metrics rule|
					metrics := self calculateSupportForCondition: (considered reducedIntent) conclusion: (childConcept reducedIntent).
					rule :=
						(AssociationRule
								condition:  (considered reducedIntent  collect:[:a | a wrappedElement]) 
								conclusion: (childConcept reducedIntent collect:[:a | a wrappedElement]) 
								conditionSupport: (metrics at:1)
								conclusionSupport: (metrics at:2)			
								matches: (metrics at:3)
								conditionExceptions: (metrics at:4)
								conclusionExceptions: (metrics at:5)
								objectsAnalyzed: (metrics at:6)).
					(self mustKeepRule: rule) ifTrue:[result add: rule]]].
	^result! !

!AssociationRuleMiner methodsFor: 'private association mining' stamp: 'AndyKellens 7/30/2012 13:42'!
mineAssociationsBetweenSiblings
	| result |
	result := OrderedCollection new.
	consideredConcepts do: 
			[:considered |
			(consideredConcepts select: [:candidate | candidate ~= considered and: [(considered biggerOnes intersection: candidate biggerOnes) notEmpty]]) do: 
					[:sibling |
					sibling smallerOnes do: 
							[:child |
							| properties metrics rule |
							properties := sibling reducedIntentRep bitOr: (child reducedIntentRep).
							"properties := properties bitXor: (considered reducedIntentRep)."
							properties = 0
								ifFalse: 
									[|resolvedProperties|
									resolvedProperties := self context attributesRepresentedBy: properties.
									metrics := self calculateSupportForCondition: considered reducedIntent  conclusion: resolvedProperties.
									rule := AssociationRule
												condition: (considered reducedIntent collect: [:a | a wrappedElement])
												conclusion: (resolvedProperties collect: [:a | a wrappedElement])
												conditionSupport: (metrics at: 1)
												conclusionSupport: (metrics at: 2)
												matches: (metrics at: 3)
												conditionExceptions: (metrics at: 4)
												conclusionExceptions: (metrics at: 5)
												objectsAnalyzed: (metrics at:6).
									(self mustKeepRule: rule) ifTrue:[result add: rule]]]]].
	^result! !

!AssociationRuleMiner methodsFor: 'private implication mining' stamp: 'AndyKellens 7/30/2012 13:42'!
mineImplications
	rules addAll: (self mineImplicationsBetweenConcepts).
	rules addAll: (self mineImplicationsWithinConcepts)! !

!AssociationRuleMiner methodsFor: 'private implication mining' stamp: 'AndyKellens 7/30/2012 15:01'!
mineImplicationsBetweenConcepts
	| result |
	result := OrderedCollection new.
	consideredConcepts do:[:considered |
		(considered biggerOnes select:[:biggerOne | consideredConcepts includes: biggerOne]) 
			do:[:parentConcept |
				considered reducedIntent do:[:condition |
					| metrics rule|
					metrics := self calculateSupportForCondition: (OrderedCollection with: condition) conclusion: (parentConcept accumulateReducedIntent).
					rule :=
						(AssociationRule
								condition: (Array with: condition wrappedElement)
								conclusion: (parentConcept accumulateReducedIntent collect:[:a | a wrappedElement])
								conditionSupport: (metrics at:1)
								conclusionSupport: (metrics at:2)			
								matches: (metrics at:3)
								conditionExceptions: (metrics at:4)
								conclusionExceptions: (metrics at:5)
								objectsAnalyzed: (metrics at:6)).	
					(self mustKeepRule: rule) ifTrue:[result add: rule]]]].
	^result! !

!AssociationRuleMiner methodsFor: 'private implication mining' stamp: 'AndyKellens 7/30/2012 13:42'!
mineImplicationsWithinConcepts
	|result toConsider condition conclusion metrics rule|
	result := OrderedCollection new.
	toConsider := consideredConcepts select:[:concept | concept reducedIntent size > 1].
	toConsider do:[:concept |
		| withOneLess |
		withOneLess := self considerSubsetsWithOneLessOf: (concept reducedIntent asOrderedCollection).
		withOneLess do:[:candidate |
			condition := (concept reducedIntent copy removeAll: candidate;yourself).
			conclusion := candidate.
			metrics := self calculateSupportForCondition: condition conclusion: conclusion.
			rule :=
						(AssociationRule
								condition: (condition collect:[:a | a wrappedElement])
								conclusion: (conclusion collect:[:a | a wrappedElement])
								conditionSupport: (metrics at:1)
								conclusionSupport: (metrics at:2)			
								matches: (metrics at:3)
								conditionExceptions: (metrics at:4)
								conclusionExceptions: (metrics at:5)
								objectsAnalyzed: (metrics at:6)).
					(self mustKeepRule: rule) ifTrue:[result add: rule]]].
	^result! !

!AssociationRuleMiner methodsFor: 'private mining' stamp: 'AndyKellens 7/30/2012 14:16'!
mustKeepRule: aRule
	"(aRule condition asString =  'Set (C>#at:put:)') ifTrue:[self halt]."
	allRules := allRules + 1.
	"Filters S1 (matches) and S3 (confidence)"
	(aRule matches size >= self class minimumSupport
		and: [aRule confidence >= self class minimumConfidence]) ifTrue: [^true].
	aRule matches size < self class minimumSupport
		ifTrue: [pruneNoMatches := pruneNoMatches + 1]
		ifFalse: 
			[aRule confidence < self class minimumConfidence
				ifTrue: [pruneNoConfidence := pruneNoConfidence + 1]].
	^false! !

!AssociationRuleMiner methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 13:40'!
pruneNoConfidence
	^pruneNoConfidence! !

!AssociationRuleMiner methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 13:40'!
pruneNoMatches
	^pruneNoMatches! !

!AssociationRuleMiner methodsFor: 'private mining' stamp: 'AndyKellens 7/30/2012 14:13'!
selectConcepts
	| withoutTopOrBottom |
	withoutTopOrBottom := OrderedCollection new.
	withoutTopOrBottom addAll: context concepts .
	withoutTopOrBottom remove: context bottomConcept.
	withoutTopOrBottom remove: context topConcept ifAbsent:[].
	consideredConcepts := withoutTopOrBottom select:[:concept | concept reducedIntent notEmpty]! !

Object subclass: #Mentor
	instanceVariableNames: 'projectName classes matchesOverlap classMiner methodMiner associationGroups metrics metricsPerGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mentor-Core'!

!Mentor class methodsFor: 'instance creation' stamp: 'AndyKellens 7/30/2012 13:53'!
projectName: aProjectName classes: aCollection
	^super new initializeWithProjectName: aProjectName classes: aCollection! !

!Mentor methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 13:57'!
associationGroups
	^associationGroups! !

!Mentor methodsFor: 'metrics' stamp: 'AndyKellens 7/30/2012 13:57'!
calculateMetrics
	metrics := self calculateMetricsFor: (methodMiner associationGroups).
	metricsPerGroup := Dictionary new.
	self associationGroups do:[:group | group metrics: (self calculateMetricsFor: (group rules)) ]! !

!Mentor methodsFor: 'metrics' stamp: 'AndyKellens 7/30/2012 13:58'!
calculateMetricsFor: aCollection
	| result |
	result := Dictionary new.
	result 
		at:'H-H' put: Set new;
		at:'H-I' put:Set new;
		at:'H-K' put: Set new;
		at:'H-k' put: Set new;
		at:'H-R' put: Set new;
		at:'H-C' put: Set new;
		at:'H-U' put: Set new;
		at:'I-I' put: Set new;
		at:'I-K' put:Set new;
		at:'I-H' put:Set new;
		at:'I-k' put: Set new;
		at:'I-R' put: Set new;
		at:'I-C' put: Set new;
		at:'I-U' put: Set new;
		at:'K-I' put: Set new;
		at:'K-H' put: Set new;
		at:'K-K' put: Set new;
		at:'K-k' put: Set new;
		at:'K-R' put: Set new;
		at:'K-C' put: Set new;
		at:'K-U' put: Set new;
		at:'k-H' put: Set new;
		at:'k-I' put:Set new;
		at:'k-K' put: Set new;
		at:'k-k' put: Set new;
		at:'k-R' put: Set new;
		at:'k-C' put: Set new;
		at:'k-U' put: Set new;
		at:'R-I' put: Set new;
		at:'R-K' put:Set new;
		at:'R-H' put:Set new;
		at:'R-k' put: Set new;
		at:'R-R' put: Set new;
		at:'R-C' put: Set new;
		at:'R-U' put: Set new;
		at:'C-I' put: Set new;
		at:'C-H' put: Set new;
		at:'C-K' put: Set new;
		at:'C-k' put: Set new;
		at:'C-R' put: Set new;
		at:'C-C' put: Set new;
		at:'C-U' put: Set new;
		at:'C-I' put: Set new;
		at:'U-H' put: Set new;
		at:'U-K' put: Set new;
		at:'U-k' put: Set new;
		at:'U-R' put: Set new;
		at:'U-C' put: Set new;
		at:'U-U' put: Set new.
	aCollection do:[:rule |
		(rule condition do:[:condition | 
			(condition firstLetterOfType = 'H')
							ifTrue:[
									rule conclusion do:[:conclusion |
													(conclusion firstLetterOfType = 'H') ifTrue:[(result at:'H-H') add: rule].
													(conclusion firstLetterOfType = 'I') ifTrue:[(result at:'H-I') add: rule].
													(conclusion firstLetterOfType = 'K') ifTrue:[(result at:'H-K') add: rule].
													(conclusion firstLetterOfType = 'k') ifTrue:[(result at:'H-k') add: rule].
													(conclusion firstLetterOfType = 'R') ifTrue:[(result at:'H-R') add: rule].
													(conclusion firstLetterOfType = 'C') ifTrue:[(result at:'H-C') add: rule].
													(conclusion firstLetterOfType = 'U') ifTrue:[(result at:'H-U') add: rule]
]].
			(condition firstLetterOfType = 'I')
							ifTrue:[
									rule conclusion do:[:conclusion |
													(conclusion firstLetterOfType = 'I') ifTrue:[(result at:'I-I') add: rule].
													(conclusion firstLetterOfType = 'H') ifTrue:[(result at:'I-H') add: rule].
													(conclusion firstLetterOfType = 'K') ifTrue:[(result at:'I-K') add: rule].
													(conclusion firstLetterOfType = 'k') ifTrue:[(result at:'I-k') add: rule].
													(conclusion firstLetterOfType = 'R') ifTrue:[(result at:'I-R') add: rule].
													(conclusion firstLetterOfType = 'C') ifTrue:[(result at:'I-C') add: rule].
													(conclusion firstLetterOfType = 'U') ifTrue:[(result at:'I-U') add: rule]
]].
			(condition firstLetterOfType = 'K')
							ifTrue:[
									rule conclusion do:[:conclusion |
													(conclusion firstLetterOfType = 'I') ifTrue:[(result at:'K-I') add: rule].
													(conclusion firstLetterOfType = 'H') ifTrue:[(result at:'K-H') add: rule].
													(conclusion firstLetterOfType = 'K') ifTrue:[(result at:'K-K') add: rule].
													(conclusion firstLetterOfType = 'k') ifTrue:[(result at:'K-k') add: rule].
													(conclusion firstLetterOfType = 'R') ifTrue:[(result at:'K-R') add: rule].
													(conclusion firstLetterOfType = 'C') ifTrue:[(result at:'K-C') add: rule].
													(conclusion firstLetterOfType = 'U') ifTrue:[(result at:'K-U') add: rule]
]].
			(condition firstLetterOfType = 'k')
							ifTrue:[
									rule conclusion do:[:conclusion |
													(conclusion firstLetterOfType = 'I') ifTrue:[(result at:'k-I') add: rule].
													(conclusion firstLetterOfType = 'H') ifTrue:[(result at:'k-H') add: rule].
													(conclusion firstLetterOfType = 'K') ifTrue:[(result at:'k-K') add: rule].
													(conclusion firstLetterOfType = 'k') ifTrue:[(result at:'k-k') add: rule].
													(conclusion firstLetterOfType = 'R') ifTrue:[(result at:'k-R') add: rule].
													(conclusion firstLetterOfType = 'C') ifTrue:[(result at:'k-C') add: rule].
													(conclusion firstLetterOfType = 'U') ifTrue:[(result at:'k-U') add: rule]
]].
			(condition firstLetterOfType = 'R')
							ifTrue:[
									rule conclusion do:[:conclusion |
													(conclusion firstLetterOfType = 'I') ifTrue:[(result at:'R-I') add: rule].
													(conclusion firstLetterOfType = 'H') ifTrue:[(result at:'R-H') add: rule].
													(conclusion firstLetterOfType = 'K') ifTrue:[(result at:'R-K') add: rule].
													(conclusion firstLetterOfType = 'k') ifTrue:[(result at:'R-k') add: rule].
													(conclusion firstLetterOfType = 'R') ifTrue:[(result at:'R-R') add: rule].
													(conclusion firstLetterOfType = 'C') ifTrue:[(result at:'R-C') add: rule].
													(conclusion firstLetterOfType = 'U') ifTrue:[(result at:'R-U') add: rule]
]].
			(condition firstLetterOfType = 'C')
							ifTrue:[
									rule conclusion do:[:conclusion |
													(conclusion firstLetterOfType = 'I') ifTrue:[(result at:'C-I') add: rule].
													(conclusion firstLetterOfType = 'H') ifTrue:[(result at:'C-H') add: rule].
													(conclusion firstLetterOfType = 'K') ifTrue:[(result at:'C-K') add: rule].
													(conclusion firstLetterOfType = 'k') ifTrue:[(result at:'C-k') add: rule].
													(conclusion firstLetterOfType = 'R') ifTrue:[(result at:'C-R') add: rule].
													(conclusion firstLetterOfType = 'C') ifTrue:[(result at:'C-C') add: rule].
													(conclusion firstLetterOfType = 'U') ifTrue:[(result at:'C-U') add: rule]
]].
			(condition firstLetterOfType = 'U')
							ifTrue:[
									rule conclusion do:[:conclusion |
													(conclusion firstLetterOfType = 'I') ifTrue:[(result at:'U-I') add: rule].
													(conclusion firstLetterOfType = 'H') ifTrue:[(result at:'U-H') add: rule].
													(conclusion firstLetterOfType = 'K') ifTrue:[(result at:'U-K') add: rule].
													(conclusion firstLetterOfType = 'k') ifTrue:[(result at:'U-k') add: rule].
													(conclusion firstLetterOfType = 'R') ifTrue:[(result at:'U-R') add: rule].
													(conclusion firstLetterOfType = 'C') ifTrue:[(result at:'U-C') add: rule].
													(conclusion firstLetterOfType = 'U') ifTrue:[(result at:'U-U') add: rule]

]]])].
	^result! !

!Mentor methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 13:57'!
classMiner
	^classMiner! !

!Mentor methodsFor: 'private' stamp: 'AndyKellens 7/30/2012 13:58'!
groupRules 
	| toGroup |
	toGroup := Dictionary new.
	associationGroups := associationGroups asSortedCollection:[:g1 :g2 | (g1 matches) size >= (g2 matches)  size].
	"ConceptElementWrapper::getClass MUST BE CHANGED TO HANDLE METHODS IN JAVA"
	associationGroups do:[:rule | |key candidateKey| 
								key := Set new. 
								rule matches do: [:each | 	(key includes: (each )) ifFalse:[key add: (each )].].
		candidateKey := Set new.
		(toGroup keysDo: [:otherKey| |overlap| 
			overlap := 0 asFloat.
			(otherKey includesAnyOf: key)
				ifTrue: [ |currentOverlap|
					currentOverlap := ((key size)/(otherKey size)) asFloat.
					( currentOverlap >= matchesOverlap and:[ currentOverlap > overlap])
						ifTrue: [ overlap := currentOverlap. candidateKey := otherKey].
				].
		]).
		candidateKey size = 0
			ifTrue: [candidateKey := key].
		(toGroup at: candidateKey ifAbsentPut:[Set new]) add: rule .].
	"associationGroups do:[:rule | |key isClass| 
			(isClass := self isAClass: (rule matches asOrderedCollection first) ) 
					ifTrue: [ key := rule matches asSet]
					ifFalse: [key := rule matches collect: [:each | each class].
			].
		(toGroup at: key ifAbsentPut:[Set new]) add: rule .]."
	
	associationGroups := toGroup values collect:[:eachGroup | | propDictionary setOfProps |
				propDictionary := Dictionary new.
				setOfProps := Set new.
				eachGroup do: [:aRule | setOfProps addAll: (aRule condition); addAll: aRule conclusion].
				setOfProps do: [:aProp | |bitRep | 
					classMiner context 
						ifNil:[bitRep := methodMiner context attributes at: aProp]
						ifNotNil:[	bitRep := classMiner context  attributes at: aProp ifAbsent: [methodMiner context attributes at: aProp]].
					propDictionary at: aProp put: bitRep]. 
				RuleGroup withRules: eachGroup withDictionary: propDictionary].

	""associationGroups := associationGroups asSortedCollection:[:g1 :g2 | (g1 support)  >= (g2 support)]
	"^toGroup"! !

!Mentor methodsFor: 'initialize-release' stamp: 'AndyKellens 7/30/2012 13:56'!
initializeWithProjectName: aProjectName classes: aCollection
	| allMethods |
	projectName := aProjectName.
	classes := aCollection.
	matchesOverlap := 0.75.
	allMethods := OrderedCollection new.
	classes do:[:theClass | allMethods addAll: (theClass selectors collect:[:each | (theClass >> each) ])].
	classMiner := ClassCodeMiner objects: classes project: projectName.
	methodMiner := MethodCodeMiner objects: allMethods project: projectName.! !

!Mentor methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 13:57'!
methodMiner
	^methodMiner! !

!Mentor methodsFor: 'mining' stamp: 'AndyKellens 7/30/2012 15:31'!
mine
	classMiner mine.
	methodMiner mine.
	associationGroups := OrderedCollection new.
	associationGroups addAll: methodMiner associationGroups.
	associationGroups addAll: classMiner associationGroups.
	self groupRules! !

!Mentor methodsFor: 'printing' stamp: 'AndyKellens 7/30/2012 13:58'!
printOn: aStream
	|groupCounter countMetrics|
	countMetrics := 1.
	groupCounter := 0.
	aStream nextPutAll: 'GROUPS:',associationGroups size asString;cr.
	countMetrics = 1 ifTrue:[aStream nextPutAll: 'props	match	rules	conf.	sup.		lift	conv.';cr.].
	associationGroups do: [:group| groupCounter:= groupCounter+1. aStream nextPutAll: "groupCounter asString, ')', "group asString;cr].! !

Object subclass: #RuleGroup
	instanceVariableNames: 'rules propDictionary metrics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mentor-Core'!

!RuleGroup class methodsFor: 'instance creation' stamp: 'AndyKellens 7/30/2012 14:00'!
withRules: aGroup withDictionary: aPropDictionary
	^ self new withRules: aGroup withDictionary: aPropDictionary! !

!RuleGroup methodsFor: 'metrics' stamp: 'AndyKellens 7/30/2012 14:00'!
confidence
	|  avgConf |
	avgConf :=0. 
	rules do: [:rule| 
			avgConf :=avgConf +rule confidence.
			].
	avgConf := avgConf / (rules size) asFloat .
	^avgConf! !

!RuleGroup methodsFor: 'metrics' stamp: 'AndyKellens 7/30/2012 14:00'!
conviction
	| avgConv|
	avgConv:=0.
	rules do: [:rule| 
			avgConv:=avgConv+rule conviction.
			].
	avgConv:=avgConv / (rules size) asFloat.
	^avgConv! !

!RuleGroup methodsFor: 'metrics' stamp: 'AndyKellens 7/30/2012 14:00'!
exceptions
	| result |
	result := Set new.
	self rules do:[:rule |
		result addAll: (rule conditionSupport).
		result addAll: (rule conclusionSupport).
		].
	^result removeAll: (self matches);yourself! !

!RuleGroup methodsFor: 'metrics' stamp: 'AndyKellens 7/30/2012 14:00'!
lift
	| avgLift |
	avgLift:=0. 
	rules do: [:rule| 
			avgLift:=avgLift+rule lift.
			].
	avgLift:=avgLift / (rules size) asFloat.
	^avgLift! !

!RuleGroup methodsFor: 'metrics' stamp: 'AndyKellens 7/30/2012 14:01'!
matches
	| ruleWithMinMatches |
	ruleWithMinMatches := rules inject: (rules asOrderedCollection first ) into: [:rule1 :rule2| 
									(rule1 matches size) < (rule2 matches size) 
									ifTrue: [rule1]
									ifFalse: [rule2]].
	^ ruleWithMinMatches matches! !

!RuleGroup methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 14:00'!
metrics
	^metrics! !

!RuleGroup methodsFor: 'printing' stamp: 'AndyKellens 7/30/2012 14:02'!
printOn: aStream
	| propertiesStr countMetrics|
	countMetrics := 0.
	propertiesStr := self properties asOrderedCollection asString.
	propertiesStr := propertiesStr copyFrom: ('OrderedCollection (' size+1) to: (propertiesStr size - 1).

	countMetrics = 1
	ifTrue:[aStream nextPutAll: self properties size asString,'	',self matches size asString,'	', rules size asString,'	'
							,self confidence  asString,'	',self support  asString,'	',self lift  asString,'	',self conviction  asString.]
	ifFalse:[
	aStream nextPutAll:' ';cr.
	aStream nextPutAll: self properties size asString,' properties',', ', self matches size asString,' matches, ', rules size asString,' rules'
	,'. Props: ', propertiesStr
	,'. Matches: '. 
	self matches do: [:match| aStream nextPutAll: match name,'		'].
	aStream nextPutAll:' ';cr.
	aStream nextPutAll:'Rules: ';cr.
	rules do: [:rule| 
			aStream nextPutAll: rule printString.
			"aStream nextPutAll: '	---lift (if close to 1 asociation is by chance):',(rule lift asInteger) asString,' conviction (likelihood of co-change or strengh of the direction): '.
			(rule conviction asInteger) = 99999 ifTrue:[aStream nextPutAll: 'infinity';cr.] ifFalse:[aStream nextPutAll: (rule conviction asInteger) asString;cr.]."
			aStream nextPutAll: '	---exceptions: '.
			rule conditionExceptions do: [:exception| aStream nextPutAll: exception name,'	'.].
			aStream nextPutAll:' ';cr.
			].
	aStream nextPutAll:'Confidence: ',self confidence  asString,' Support: ',self support  asString,' Lift: ',self lift  asString,' Conviction: ',self conviction  asString;cr.].! !

!RuleGroup methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 14:00'!
propDictionary
	^propDictionary! !

!RuleGroup methodsFor: 'metrics' stamp: 'AndyKellens 7/30/2012 14:01'!
properties
	| properties |
	properties := Set new.
	rules do: [:rule| properties addAll: (rule condition). properties addAll: (rule conclusion).].
	^properties! !

!RuleGroup methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 14:00'!
rules
	^rules! !

!RuleGroup methodsFor: 'metrics' stamp: 'AndyKellens 7/30/2012 14:01'!
support
	| avgSupp |
	avgSupp:=0. 
	rules do: [:rule| 
			avgSupp:=avgSupp+rule conditionSupport size.
			].
	avgSupp:=avgSupp / (rules size) asFloat.
	^avgSupp! !

!RuleGroup methodsFor: 'initialize-release' stamp: 'AndyKellens 7/30/2012 15:30'!
withRules: aSetOfRules withDictionary: aPropDictionary
	"CHECK HERE IF THE RULES CAN BE FILTERED: I.E. IF YOU DO NOT LOOSE PROPERTIES BY ELIMINATING A RULE: see filter by importance"
	|filteredRules initialProperties finalProperties debug rulesToEliminate match1|
	filteredRules := aSetOfRules.
	initialProperties := Set new.
	aSetOfRules do: [:rule| initialProperties addAll: (rule condition).].
	"filter"
	debug := 1.
	match1 := ((aSetOfRules asOrderedCollection at:1) matches asOrderedCollection at:1) wrappedElement.
	(match1 isKindOf: ClassDescription) 
		ifTrue:[rulesToEliminate := filteredRules select: [:eachRule | (eachRule isUnique) and: [eachRule firstConditionProperty importanceForClass > eachRule firstConclusionProperty importanceForClass] ]. ]
		ifFalse:[rulesToEliminate := filteredRules select: [:eachRule | (eachRule isUnique) and: [eachRule firstConditionProperty importanceForMethods > eachRule firstConclusionProperty importanceForMethods] ].].
	debug =1 ifTrue:[rulesToEliminate do:[:each | Transcript show:'-:',each asString].]. 
	filteredRules := filteredRules  copyWithoutAll: rulesToEliminate.
	finalProperties := Set new.
	filteredRules do: [:rule| finalProperties addAll: (rule condition).].
	finalProperties = initialProperties
		ifFalse:[rules := aSetOfRules]
		ifTrue:[rules := filteredRules].
	propDictionary := aPropDictionary.
	"self buildMatrix"! !

!Collection methodsFor: '*mentor-core' stamp: 'AngelaLozano 9/27/2012 16:42'!
equalsTo: aCollection 
"Answer true if the reciever contains the same elements as aCollection, and vice versa."

^(aCollection isCollection) 
and: [ aCollection size = self size 
and: [ aCollection allSatisfy: [ :each | 
(aCollection occurrencesOf: each) = (self occurrencesOf: each) ]]]! !

!Collection methodsFor: '*Mentor-Core' stamp: 'AndyKellens 7/30/2012 15:04'!
removeAll: aCollection ifAbsent: aBlock
	"Remove each element of aCollection from the receiver. If successful for 
	each, answer aCollection. Otherwise create an error notification.
	ArrayedCollections cannot respond to this message."

	aCollection == self ifTrue: [^self removeAll].
	aCollection do: [:each | self remove: each ifAbsent:aBlock].
	^ aCollection! !
